//
//  BDExpressionAssignment.m
//  BDRuleEngine
//
//  Created by narita on 2015/05/13.
//  Copyright (c) 2015年 narita. All rights reserved.
//

#import "BDExpressionAssignment.h"

@interface BDExpressionAssignment ()

@property (retain, readwrite) NSExpression*       expression;

@end

@implementation BDExpressionAssignment

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

- (id)initWithKeyPath:(NSString *)inKeyPath value:(id)inValue
{
    if (self = [super initWithKeyPath:inKeyPath value:inValue])
    {
        self.expression = [NSExpression expressionWithFormat:self.value];;
    }
    
    return self;
}

#pragma mark -
#pragma mark dealloc

- (void)dealloc
{
    self.expression = nil;
}

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark BDPropertyListEncoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

#pragma mark -
#pragma mark Utility methods

- (id)fireInContext:(BDRuleContext *)context
{
    id result = nil;
    
    // 評価式をこのコンティキストで評価
    if( self.expression )
    {
        result = [self.expression expressionValueWithObject:context
                                                      context:nil];
    }
    
    return result;
}

@end
