/*
    Copyright (c) 2002, 2003, bDistributed.com, Inc.
    All rights reserved.

    Redistribution and use in source and binary forms, with or
    without modification, are permitted provided that the following
    conditions are met:

    *   Redistributions of source code must retain the above
        copyright notice, this list of conditions and the following
        disclaimer.
    
    *   Redistributions in binary form must reproduce the above
        copyright notice, this list of conditions and the following
        disclaimer in the documentation and/or other materials
        provided with the distribution.
    
    *   Neither the name of bDistributed.com, Inc. nor the names of
        its contributors may be used to endorse or promote products
        derived from this software without specific prior written
        permission.

    THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
    CONTRIBUTORS ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES,
    INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
    DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE
    LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY,
    OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
    PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
    OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR
    TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
    OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
    OF SUCH DAMAGE.
*/

#import <Foundation/Foundation.h>

@class BDRuleModel;

@interface BDRuleContext : NSObject
{
    BDRuleModel *model;
    NSMutableDictionary *storedValues;
}

#pragma mark -
#pragma mark class methods

#pragma mark -
#pragma mark init methods

- (id)init;
- (id)initWithModel:(BDRuleModel *)model; /* designated initializer */

#pragma -
#pragma mark dealloc
- (void)dealloc;

#pragma mark -
#pragma mark NSCopying, hash, isEqual:

#pragma mark -
#pragma mark NSCoding methods

#pragma mark -
#pragma mark BDPropertyListEncoding methods

#pragma mark -
#pragma mark awakeFromNib-like methods

#pragma mark -
#pragma mark action methods

#pragma mark -
#pragma mark delegate/datasource methods

#pragma mark -
#pragma mark accessor methods (in pairs)

@property (retain, readwrite) BDRuleModel* model;

#pragma mark -
#pragma mark Utility methods

// getter Helper
- (NSInteger) integerForKey:(NSString*)keyName;
- (NSUInteger) unsignedIntegerForKey:(NSString*)keyName;
- (float) floatForKey:(NSString*)keyName;
- (double) doubleForKey:(NSString*)keyName;
- (BOOL) boolForKey:(NSString*)keyName;

// setter Helper
- (void)setInteger:(NSInteger)value forKey:(NSString*)keyName;
- (void)setUnsignedIntegerForKey:(NSUInteger)value forKey:(NSString*)keyName;
- (void)setFloat:(float)value forKey:(NSString *)keyName;
- (void)setDouble:(double)value forKey:(NSString*)keyName;
- (void)setBool:(BOOL)value forKey:(NSString*)keyName;

#pragma mark -
#pragma mark KVC

- (id)valueForKey:(NSString *)key;
- (void)setValue:(id)value forKey:(NSString *)key;

- (id)storedValueForKey:(NSString *)key;
- (void)takeStoredValue:(id)value
                 forKey:(NSString *)key;

- (id)inferredValueForKey:(NSString *)key;

- (NSArray *)valuesForKeyPath:(NSString *)keyPath
       takingSuccessiveValues:(NSArray *)values
                   forKeyPath:(NSString *)valueKeyPath;
@end
